--
-- NEW HOLLAND BB9080R
--
-- 

NHBB9080R = {};

function NHBB9080R.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function tmp(s, prom)
   if prom~=nil then   
     for k,v in pairs(prom) do
      print(s..tostring(k).."("..type(v)..") = "..tostring(v));
      if type(v)=="table" then
        tmp((s.."  "),prom[k]);
      end;
     end;
   end;
end;

function NHBB9080R:load(xmlFile) 
    -- Brake lights
    self.brakeLightObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.brake#index"));
    setVisibility(self.brakeLightObject, false);
    self.brakeLightActive = false;
    
    -- Turn lights
    self.leftTurnObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.leftTurn#index"))
    setVisibility(self.leftTurnObject, false);
    self.leftTurnActive = false;
    self.flashLeft = false;
    
    self.rightTurnObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.rightTurn#index"))
    setVisibility(self.rightTurnObject, false);
    self.rightTurnActive = false;
    self.flashRight = false;
    
    self.flash = false;
    self.flashWarn = false;
    self.timer = 10;

	-- Capacity for Ropes --

    self.RopeCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.RopeCapacity"), 50);
	
	-- Animations and moving collisions --

	self.connectCollisions = SpecializationUtil.callSpecializationsFunction("connectCollisions");
	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
  	self.charId = {};
	self.clipIndex = {};
	self.Go = {}; 
	self.Done = {};
	self.CheckDone = {};
	self.collisionArm = {}; 
	self.moveColli = {}; 
	local count = getXMLInt(xmlFile, "vehicle.animParts#count");
    self.animParts = {}
	local part = self.animParts;
    for i=1, count do
		part[i] = {};
        local partname = string.format("vehicle.animParts.part".."%d", i);
	    local nameR = getXMLString(xmlFile, partname.."#name");
		self.charId[nameR] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partname.."#rootNode"));
		self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
		self.CheckDone[nameR] = false;
		
		self.moveColli[nameR] = getXMLString(xmlFile, partname.."#moveColli");
		if self.moveColli[nameR] ~= nil then
			local Collision = {};
			Collision.collision = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partname.."#collision"));
			Collision.collisionAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partname.."#collsionAttacher"));
			Collision.armAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partname.. "#armAttacher"));
			Collision.index = 0;
			self.collisionArm[nameR] = Collision;
			self:connectCollisions(nameR);
		end; 
	end; 	
	
	-- KEYS --

	self.keys = {};
	self.keysName = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
		self.keysName[inputName] = Utils.getNoNil(getXMLString(xmlFile, baseName.."#keyname"),"Touche ?");
        i = i+1;
    end;
	
	-- Dust --
	
	self.dustParticleSystems = {};
    local dustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dustParticleSystems#count"), 0);
    for i=1, dustParticleSystemCount do
        local namei = string.format("vehicle.dustParticleSystems.part%d", i);
		local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.dustParticleSystems, namei, nodei, false, nil, self.baseDirectory)
    end;
	
	-- Objects TEST ( don't forget to use a loop ) --
	
	    self.PU1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PU1#index"));
	    self.PU2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PU2#index"));
	    self.PU3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PU3#index"));
	    self.PU4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PU4#index"));
	    self.PU5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PU5#index"));
	    self.Fan1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Fan1#index"));
	    self.Fan2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Fan2#index"));
	    self.Fan3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Fan3#index"));
	    
		self.Ropes = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Ropes#index"));
				
	-- Instance --
	
	self.TransportMode = false;
	self.PickupON = false;
	self.isReady = false;
	self.isActivate = false;
	
	-- Sound for "no Ropes " --

    NoRopeSoundFile = Utils.getFilename("Sounds/NoRope.ogg", self.baseDirectory);
    self.NoRopeSoundId = createSample("NoRopeSound");
    loadSample(self.NoRopeSoundId, NoRopeSoundFile, false);
    self.NoRopePlaying = false;
	
	-- PDA --
	
	self.File = Utils.getFilename("Textures/BoitierBB980.png", self.baseDirectory);
	self.hudPDAPoxX = 0.5;
    self.hudPDAPoxY = 1-0.150; 
    self.hudPDAWidth = 0.220;
    self.hudPDAHeight = 0.130;
	self.hudBasePoxX = 0.57;
    self.hudBasePoxY = 0.925; 
	self.hudBase2PoxX = 0.536;
    self.hudBase2PoxY = 0.88; 	
    self.HUDNHBB = Overlay:new("HUDNHBB", self.File, self.hudPDAPoxX, self.hudPDAPoxY, self.hudPDAWidth, self.hudPDAHeight);
    self.PDA = false;
	self.noRopes = false;
	self.hasRopes = true;
	self.NR = true;
	self.RopesPDA = false;
	self.canBeReload = false;
	
end;

function NHBB9080R:delete()
	removeJoint(self.collisionArm.support.index); 
	Utils.setEmittingState(self.dustParticleSystems, false)
    if self.NoRopeSound ~= nil then
        delete(self.NoRopeSound);
    end;
end;

function NHBB9080R:mouseEvent(posX, posY, isDown, isUp, button)
end;

function NHBB9080R:keyEvent(unicode, sym, modifier, isDown)

    -- Turn signals
    if InputBinding.isPressed(InputBinding.LEFTTURN) then
        if not self.flashLeft or self.flashWarn then
            self.flashLeft = false;
        end;
        self.flashLeft = not self.flashLeft;
        self.flashRight = false;
        self.flashWarn = false;
        self.timer = 10;
    end;
    if InputBinding.isPressed(InputBinding.RIGHTTURN) then
        if not self.flashRight or self.flashWarn then
            self.flashRight = false;
        end;
        self.flashRight = not self.flashRight;
        self.flashLeft = false;
        self.flashWarn = false;
        self.timer = 10;
    end;
    -- Warn lights
    if InputBinding.isPressed(InputBinding.WARNLIGHTS) then
        if self.flashWarn then
            self.flashLeft = false;
            self.flashRight = false;
        else
            self.rightTurnActive = false;
            self.leftTurnActive = false;
            self.flashLeft = true;
            self.flashRight = true;
        end;
        self.flashWarn = not self.flashWarn;
        self.timer = 10;
    end;

	if isDown and sym==self.keys.transport and not self.isActivate and not self.isTurnedOn then
		self.isReady = not self.isReady;
		self.Go.transport = not self.Go.transport; 
		self.Done.transport = true; 
	end;

	if isDown and sym==self.keys.activate and self.isReady then
		self.isActivate = not self.isActivate;
	end;
	
	if isDown and sym==self.keys.down  then
		self.isTurnedOn = not self.isTurnedOn;		
		self.Go.pickup = not self.Go.pickup; 
		self.Done.pickup = true; 
	end;
		
	if isDown and sym==self.keys.PDA then
		self.PDA = not self.PDA; 
	end; 
	
end;

function NHBB9080R:update(dt)

    -- Define input
    self.input = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
    if InputBinding.isAxisZero(self.input) then
        self.input = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
    end;
    
    -- Brake lights
    setVisibility(self.brakeLightObject, self.brakeLightActive);
    
    if (self.movingDirection*self.lastSpeed*(-self.input)) < -0.001 then
        self.brakeLightActive = true;
    else
        self.brakeLightActive = false;
    end;
    
	-- Turn lights
    if self.flashLeft or self.flashRight then
        self.timer = self.timer - dt;
        if self.flashRight or self.flashWarn then
            if self.timer < 0 then
                self.rightTurnActive = not self.rightTurnActive;
            end;
        else
            self.rightTurnActive = false;
        end;
    
        if self.flashLeft or self.flashWarn then
            if self.timer < 0 then
                self.leftTurnActive = not self.leftTurnActive;
            end;
        else
            self.leftTurnActive = false;
        end;
        if self.timer < 0 then
            self.timer = 500;
        end;
    else
        self.rightTurnActive = false;
        self.leftTurnActive = false;
    end;
    setVisibility(self.rightTurnObject, self.rightTurnActive);
    setVisibility(self.leftTurnObject, self.leftTurnActive);
  
	if self.attacherVehicle then  

		-- Animations and movements -- 
		
		if self.Go.transport ~= nil and self.Done.transport ~= false then			
			self:anim("transport",false); 
		end; 	

		if self.Go.catadioptre ~= nil and self.Done.catadioptre ~= false then			
			self:anim("catadioptre",false); 
		end; 

		if self.Go.door ~= nil and self.Done.door ~= false then			
			self:anim("door",false); 
		end; 
		
        if self.Go.pickup ~= nil and self.Done.pickup ~= false then			
			self:anim("pickup",false); 
		end; 
		
		if self.Go.support ~= nil and self.Done.support ~= false then
			self:anim("support", false); 
		end; 


		if self.isReady and self.isActivate then
			rotate(self.PU1, dt*-0.01, 0, 0);
			rotate(self.PU2, dt*-0.01, 0, 0);
			rotate(self.PU3, dt*0.009, 0, 0);
			rotate(self.PU4, dt*-0.01, 0, 0);
			rotate(self.PU5, dt*-0.003, 0, 0);
			rotate(self.Fan1, dt*0, 0, -2);
			rotate(self.Fan2, dt*0, 0, -2);
			rotate(self.Fan3, dt*0, 0, -2);
		end;
		
		-- Key system for the "in range " option --
		
    if getUserInRange(self.rootNode, 6) then
			if InputBinding.hasEvent(InputBinding.DOOR) then
				self.Go.door = not self.Go.door; 
				self.Done.door = true; 
			end;	
			if InputBinding.hasEvent(InputBinding.RELOAD) and self.canBeReload then
				self.hasRopes = true;
		                g_currentMission.missionStats.money = g_currentMission.missionStats.money-1000;
			end;	
			if InputBinding.hasEvent(InputBinding.SUPPORT)  then
				self.Go.support = not self.Go.support; 
				self.Done.support = true; 
			end;
		end;
		
		-- Display info when in range --
		
		if getUserInRange(self.rootNode, 6) then
			g_currentMission:addExtraPrintText(string.format("Key %s: Seitenklappe auf/zu", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DOOR)));
			g_currentMission:addExtraPrintText(string.format("Key %s: Standfuss auf/ab", InputBinding.getKeyNamesOfDigitalAction(InputBinding.SUPPORT)));
			if self.RopesPDA then
				g_currentMission:addExtraPrintText(string.format("Key %s: Neue Schnur einsetzen 1000 Euro", InputBinding.getKeyNamesOfDigitalAction(InputBinding.RELOAD)));
			end;
		end;
		
		-- No more Ropes / Reload -- 
		
		if self.noRopes then
			setVisibility(self.Ropes, false);
			self.hasRopes = false;	
			self.NR = false;
		else
			setVisibility(self.Ropes, true);
		end;
		
		if self.hasRopes  then
			self.noRopes = false;
			setVisibility(self.Ropes, true);
			self.RopesPDA = false;
		else 
			setVisibility(self.Ropes, false);
			self.RopesPDA = true;
		end;

		if self.NHBaleCount == self.RopeCapacity and self.hasRopes and self.NR then
			self.noRopes = true;
			self.isActivate = false;
			Utils.setEmittingState(self.dustParticleSystems, false)
			self.canBeReload = true;
		else
			self.noRopes = false;
		end;		

		if self.RopesPDA then
			if self:getIsActiveForSound() then
				if not self.NoRopePlaying then
					playSample(self.NoRopeSoundId, 1, 1, 0);
					self.NoRopePlaying = true;
				end;
			end;
		else
			if self.NoRopePlaying then
				stopSample(self.NoRopeSoundId);
				self.NoRopePlaying = false;
			end;
		end;
	end;


end;

function NHBB9080R:draw()
	if self.attacherVehicle ~= nil then
	
		if self.isReady then
			if self.isActivate then
				g_currentMission:addExtraPrintText(string.format("%s : Presse ausschalten",self.keysName.activate));		
			else
				g_currentMission:addExtraPrintText(string.format("%s : Presse anschalten",self.keysName.activate));		
			end;
		end;
		
		if self.isActivate then
			if self.isTurnedOn then
				g_currentMission:addExtraPrintText(string.format("%s : Pickup heben",self.keysName.down));
			else
				g_currentMission:addExtraPrintText(string.format("%s : Pickup senken",self.keysName.down));
			end;
		end;
		
		if not self.isActivate then
			if self.isReady then
				g_currentMission:addExtraPrintText(string.format("%s : Presskanal zu",self.keysName.transport));
			else
				g_currentMission:addExtraPrintText(string.format("%s : Presskanal auf",self.keysName.transport));
			end;
		end;
		
		if self.PDA then
			g_currentMission:addExtraPrintText(string.format("%s : PDA AUS",self.keysName.PDA));
		else
			g_currentMission:addExtraPrintText(string.format("%s : PDA AN",self.keysName.PDA));
		end; 
		
		if self.PDA then
			self.HUDNHBB:render();
			setTextBold(true);
			setTextColor(0, 0, 0, 1.0);
			if self.NHBaleCount >= 10 then
				self.hudBasePoxX = 0.57 - 0.007;
			end; 
			if self.NHBaleCount >= 100 then
				self.hudBasePoxX = 0.57 - 0.015;
			end; 
			if self.NHBaleCount >= 1000 then
				self.hudBasePoxX = 0.57 - 0.023;
			end; 
			if self.NHBaleCount >= 10000 then
				self.hudBasePoxX = 0.57 - 0.030;
			end; 
			if self.NHBaleCount >= 100000 then
				self.hudBasePoxX = 0.57 - 0.038;
			end; 
			if self.NHBaleCount >= 1000000 then
				self.hudBasePoxX = 0.57 - 0.045;
			end; 
		
			renderText(self.hudBasePoxX, self.hudBasePoxY, 0.020, string.format(self.NHBaleCount));
				if self.RopesPDA then
					renderText(self.hudBase2PoxX, self.hudBase2PoxY, 0.015, string.format("Kein Seil"));
				end;
		end;
		
		
	end;
end;

function NHBB9080R:onDetach()
	Utils.setEmittingState(self.dustParticleSystems, false)
	self.isActivate = false;
    stopSample(self.balerSound);
end;

function NHBB9080R:onAttach()
end; 

function NHBB9080R:anim(varName, loopCheck)
	if self.moveColli[varName] ~= nil then
		local Collision = self.collisionArm[varName];
		setJointFrame(Collision.index, 0, Collision.armAttacher);
	end;
	
	if self.Go[varName] == true and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, 1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
			disableAnimTrack(charId, 0);	
			self.Done[varName] = false;	
			self.CheckDone[varName] = true;	     
		end; 
	elseif self.Go[varName] == false and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		if loopCheck == true then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;	
		end; 	
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, -1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) <= 0 then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;	
			self.CheckDone[varName] = false;
		end;
	end;
end; 	


function NHBB9080R:connectCollisions(varName)
	local Collision = self.collisionArm[varName];
	local constr = JointConstructor:new();
	constr:setActors(self.rootNode, Collision.collision);
	constr:setJointTransforms(Collision.armAttacher, Collision.collisionAttacher);
	for i=1, 3 do		            
		constr:setRotationLimit(i-1, 0, 0, 0);
		constr:setTranslationLimit(i-1, true, 0, 0);
	end;
	Collision.index = constr:finalize();
end;

function getUserInRange(node, minDistance)
  local result = false; 
  local px, py, pz = getWorldTranslation(node);
  local Pl = 0;
  for k,v in pairs(g_currentMission.players) do
    if g_currentMission.players[k].isControlled then
      Pl = g_currentMission.players[k].rootNode;
      break;
    end; 
  end;
  if Pl ~= 0 then
    local vx, vy, vz = getWorldTranslation(Pl);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
    if distance < minDistance then		
      result = true;
    end;
  end;
  return result;
end;
